## Contributing

Hi there! We're thrilled that you'd like to contribute to this project. Your help is essential for keeping it great.

Please note that this project is released with a [Contributor Code of Conduct][code-of-conduct]. By participating in this project you agree to abide by its terms.

## Issues and PRs

If you have suggestions for how this project could be improved, or want to report a bug, open an issue! We'd love all and any contributions. If you have questions, too, we'd love to hear them.

We'd also love PRs. If you're thinking of a large PR, we advise opening up an issue first to talk about it, though! Look at the links below if you're not sure how to open a PR.

## Submitting a pull request

1. Fork and clone the repository. 
   git clone https://github.com/your_user_name/College-Library-Website.git
   Fork [this](https://github.com/urvashi-code1255/College-Library-Website) repository.
2. Add a reference(remote) to the original repository to get all the changes from the remote.
   git remote add upstream https://github.com/urvashi-code1255/College-Library-Website.git 
3. Navigate to the project directory :file_folder: cd College-Library-Website
4. Check the remotes for this repository.
   git remote -v
5. Always take a pull from the upstream repository to your master branch to keep it at par with the main project.
   git pull upstream master
6. Create a new branch: `git checkout -b my-branch-name`.
7. Perfom your desired changes to the code base.
8. Push to your fork and submit a pull request.
9. Pat your self on the back and wait for your pull request to be reviewed and merged.

Here are a few things you can do that will increase the likelihood of your pull request being accepted:

- Follow the [style guide][style] which is using standard. Any linting errors should be shown when running `npm test`.
- Write and update tests.
- Keep your changes as focused as possible. If there are multiple changes you would like to make that are not dependent upon each other, consider submitting them as separate pull requests.
- Write a [good commit message](http://tbaggery.com/2008/04/19/a-note-about-git-commit-messages.html).

Work in Progress pull requests are also welcome to get feedback early on, or if there is something blocked you.

## Resources

- [How to Contribute to Open Source](https://opensource.guide/how-to-contribute/)
- [Using Pull Requests](https://help.github.com/articles/about-pull-requests/)
- [GitHub Help](https://help.github.com)
